package com.hai.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class OutRechargeOrderExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public OutRechargeOrderExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andRechargePriceIsNull() {
            addCriterion("recharge_price is null");
            return (Criteria) this;
        }

        public Criteria andRechargePriceIsNotNull() {
            addCriterion("recharge_price is not null");
            return (Criteria) this;
        }

        public Criteria andRechargePriceEqualTo(BigDecimal value) {
            addCriterion("recharge_price =", value, "rechargePrice");
            return (Criteria) this;
        }

        public Criteria andRechargePriceNotEqualTo(BigDecimal value) {
            addCriterion("recharge_price <>", value, "rechargePrice");
            return (Criteria) this;
        }

        public Criteria andRechargePriceGreaterThan(BigDecimal value) {
            addCriterion("recharge_price >", value, "rechargePrice");
            return (Criteria) this;
        }

        public Criteria andRechargePriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("recharge_price >=", value, "rechargePrice");
            return (Criteria) this;
        }

        public Criteria andRechargePriceLessThan(BigDecimal value) {
            addCriterion("recharge_price <", value, "rechargePrice");
            return (Criteria) this;
        }

        public Criteria andRechargePriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("recharge_price <=", value, "rechargePrice");
            return (Criteria) this;
        }

        public Criteria andRechargePriceIn(List<BigDecimal> values) {
            addCriterion("recharge_price in", values, "rechargePrice");
            return (Criteria) this;
        }

        public Criteria andRechargePriceNotIn(List<BigDecimal> values) {
            addCriterion("recharge_price not in", values, "rechargePrice");
            return (Criteria) this;
        }

        public Criteria andRechargePriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("recharge_price between", value1, value2, "rechargePrice");
            return (Criteria) this;
        }

        public Criteria andRechargePriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("recharge_price not between", value1, value2, "rechargePrice");
            return (Criteria) this;
        }

        public Criteria andTypeIsNull() {
            addCriterion("`type` is null");
            return (Criteria) this;
        }

        public Criteria andTypeIsNotNull() {
            addCriterion("`type` is not null");
            return (Criteria) this;
        }

        public Criteria andTypeEqualTo(Integer value) {
            addCriterion("`type` =", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotEqualTo(Integer value) {
            addCriterion("`type` <>", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThan(Integer value) {
            addCriterion("`type` >", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("`type` >=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThan(Integer value) {
            addCriterion("`type` <", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThanOrEqualTo(Integer value) {
            addCriterion("`type` <=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeIn(List<Integer> values) {
            addCriterion("`type` in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotIn(List<Integer> values) {
            addCriterion("`type` not in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeBetween(Integer value1, Integer value2) {
            addCriterion("`type` between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("`type` not between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andOperatorNameIsNull() {
            addCriterion("operator_name is null");
            return (Criteria) this;
        }

        public Criteria andOperatorNameIsNotNull() {
            addCriterion("operator_name is not null");
            return (Criteria) this;
        }

        public Criteria andOperatorNameEqualTo(String value) {
            addCriterion("operator_name =", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameNotEqualTo(String value) {
            addCriterion("operator_name <>", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameGreaterThan(String value) {
            addCriterion("operator_name >", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameGreaterThanOrEqualTo(String value) {
            addCriterion("operator_name >=", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameLessThan(String value) {
            addCriterion("operator_name <", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameLessThanOrEqualTo(String value) {
            addCriterion("operator_name <=", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameLike(String value) {
            addCriterion("operator_name like", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameNotLike(String value) {
            addCriterion("operator_name not like", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameIn(List<String> values) {
            addCriterion("operator_name in", values, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameNotIn(List<String> values) {
            addCriterion("operator_name not in", values, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameBetween(String value1, String value2) {
            addCriterion("operator_name between", value1, value2, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameNotBetween(String value1, String value2) {
            addCriterion("operator_name not between", value1, value2, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorTypeIsNull() {
            addCriterion("operator_type is null");
            return (Criteria) this;
        }

        public Criteria andOperatorTypeIsNotNull() {
            addCriterion("operator_type is not null");
            return (Criteria) this;
        }

        public Criteria andOperatorTypeEqualTo(Integer value) {
            addCriterion("operator_type =", value, "operatorType");
            return (Criteria) this;
        }

        public Criteria andOperatorTypeNotEqualTo(Integer value) {
            addCriterion("operator_type <>", value, "operatorType");
            return (Criteria) this;
        }

        public Criteria andOperatorTypeGreaterThan(Integer value) {
            addCriterion("operator_type >", value, "operatorType");
            return (Criteria) this;
        }

        public Criteria andOperatorTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("operator_type >=", value, "operatorType");
            return (Criteria) this;
        }

        public Criteria andOperatorTypeLessThan(Integer value) {
            addCriterion("operator_type <", value, "operatorType");
            return (Criteria) this;
        }

        public Criteria andOperatorTypeLessThanOrEqualTo(Integer value) {
            addCriterion("operator_type <=", value, "operatorType");
            return (Criteria) this;
        }

        public Criteria andOperatorTypeIn(List<Integer> values) {
            addCriterion("operator_type in", values, "operatorType");
            return (Criteria) this;
        }

        public Criteria andOperatorTypeNotIn(List<Integer> values) {
            addCriterion("operator_type not in", values, "operatorType");
            return (Criteria) this;
        }

        public Criteria andOperatorTypeBetween(Integer value1, Integer value2) {
            addCriterion("operator_type between", value1, value2, "operatorType");
            return (Criteria) this;
        }

        public Criteria andOperatorTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("operator_type not between", value1, value2, "operatorType");
            return (Criteria) this;
        }

        public Criteria andOrderNoIsNull() {
            addCriterion("order_no is null");
            return (Criteria) this;
        }

        public Criteria andOrderNoIsNotNull() {
            addCriterion("order_no is not null");
            return (Criteria) this;
        }

        public Criteria andOrderNoEqualTo(String value) {
            addCriterion("order_no =", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotEqualTo(String value) {
            addCriterion("order_no <>", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoGreaterThan(String value) {
            addCriterion("order_no >", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("order_no >=", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLessThan(String value) {
            addCriterion("order_no <", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLessThanOrEqualTo(String value) {
            addCriterion("order_no <=", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLike(String value) {
            addCriterion("order_no like", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotLike(String value) {
            addCriterion("order_no not like", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoIn(List<String> values) {
            addCriterion("order_no in", values, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotIn(List<String> values) {
            addCriterion("order_no not in", values, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoBetween(String value1, String value2) {
            addCriterion("order_no between", value1, value2, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotBetween(String value1, String value2) {
            addCriterion("order_no not between", value1, value2, "orderNo");
            return (Criteria) this;
        }

        public Criteria andRechargeTypeIsNull() {
            addCriterion("recharge_type is null");
            return (Criteria) this;
        }

        public Criteria andRechargeTypeIsNotNull() {
            addCriterion("recharge_type is not null");
            return (Criteria) this;
        }

        public Criteria andRechargeTypeEqualTo(Integer value) {
            addCriterion("recharge_type =", value, "rechargeType");
            return (Criteria) this;
        }

        public Criteria andRechargeTypeNotEqualTo(Integer value) {
            addCriterion("recharge_type <>", value, "rechargeType");
            return (Criteria) this;
        }

        public Criteria andRechargeTypeGreaterThan(Integer value) {
            addCriterion("recharge_type >", value, "rechargeType");
            return (Criteria) this;
        }

        public Criteria andRechargeTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("recharge_type >=", value, "rechargeType");
            return (Criteria) this;
        }

        public Criteria andRechargeTypeLessThan(Integer value) {
            addCriterion("recharge_type <", value, "rechargeType");
            return (Criteria) this;
        }

        public Criteria andRechargeTypeLessThanOrEqualTo(Integer value) {
            addCriterion("recharge_type <=", value, "rechargeType");
            return (Criteria) this;
        }

        public Criteria andRechargeTypeIn(List<Integer> values) {
            addCriterion("recharge_type in", values, "rechargeType");
            return (Criteria) this;
        }

        public Criteria andRechargeTypeNotIn(List<Integer> values) {
            addCriterion("recharge_type not in", values, "rechargeType");
            return (Criteria) this;
        }

        public Criteria andRechargeTypeBetween(Integer value1, Integer value2) {
            addCriterion("recharge_type between", value1, value2, "rechargeType");
            return (Criteria) this;
        }

        public Criteria andRechargeTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("recharge_type not between", value1, value2, "rechargeType");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdIsNull() {
            addCriterion("mem_discount_id is null");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdIsNotNull() {
            addCriterion("mem_discount_id is not null");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdEqualTo(Long value) {
            addCriterion("mem_discount_id =", value, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdNotEqualTo(Long value) {
            addCriterion("mem_discount_id <>", value, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdGreaterThan(Long value) {
            addCriterion("mem_discount_id >", value, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdGreaterThanOrEqualTo(Long value) {
            addCriterion("mem_discount_id >=", value, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdLessThan(Long value) {
            addCriterion("mem_discount_id <", value, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdLessThanOrEqualTo(Long value) {
            addCriterion("mem_discount_id <=", value, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdIn(List<Long> values) {
            addCriterion("mem_discount_id in", values, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdNotIn(List<Long> values) {
            addCriterion("mem_discount_id not in", values, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdBetween(Long value1, Long value2) {
            addCriterion("mem_discount_id between", value1, value2, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountIdNotBetween(Long value1, Long value2) {
            addCriterion("mem_discount_id not between", value1, value2, "memDiscountId");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameIsNull() {
            addCriterion("mem_discount_name is null");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameIsNotNull() {
            addCriterion("mem_discount_name is not null");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameEqualTo(String value) {
            addCriterion("mem_discount_name =", value, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameNotEqualTo(String value) {
            addCriterion("mem_discount_name <>", value, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameGreaterThan(String value) {
            addCriterion("mem_discount_name >", value, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameGreaterThanOrEqualTo(String value) {
            addCriterion("mem_discount_name >=", value, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameLessThan(String value) {
            addCriterion("mem_discount_name <", value, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameLessThanOrEqualTo(String value) {
            addCriterion("mem_discount_name <=", value, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameLike(String value) {
            addCriterion("mem_discount_name like", value, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameNotLike(String value) {
            addCriterion("mem_discount_name not like", value, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameIn(List<String> values) {
            addCriterion("mem_discount_name in", values, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameNotIn(List<String> values) {
            addCriterion("mem_discount_name not in", values, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameBetween(String value1, String value2) {
            addCriterion("mem_discount_name between", value1, value2, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andMemDiscountNameNotBetween(String value1, String value2) {
            addCriterion("mem_discount_name not between", value1, value2, "memDiscountName");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNull() {
            addCriterion("user_id is null");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNotNull() {
            addCriterion("user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUserIdEqualTo(Long value) {
            addCriterion("user_id =", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotEqualTo(Long value) {
            addCriterion("user_id <>", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThan(Long value) {
            addCriterion("user_id >", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("user_id >=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThan(Long value) {
            addCriterion("user_id <", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThanOrEqualTo(Long value) {
            addCriterion("user_id <=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdIn(List<Long> values) {
            addCriterion("user_id in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotIn(List<Long> values) {
            addCriterion("user_id not in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdBetween(Long value1, Long value2) {
            addCriterion("user_id between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotBetween(Long value1, Long value2) {
            addCriterion("user_id not between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserNameIsNull() {
            addCriterion("user_name is null");
            return (Criteria) this;
        }

        public Criteria andUserNameIsNotNull() {
            addCriterion("user_name is not null");
            return (Criteria) this;
        }

        public Criteria andUserNameEqualTo(String value) {
            addCriterion("user_name =", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameNotEqualTo(String value) {
            addCriterion("user_name <>", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameGreaterThan(String value) {
            addCriterion("user_name >", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameGreaterThanOrEqualTo(String value) {
            addCriterion("user_name >=", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameLessThan(String value) {
            addCriterion("user_name <", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameLessThanOrEqualTo(String value) {
            addCriterion("user_name <=", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameLike(String value) {
            addCriterion("user_name like", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameNotLike(String value) {
            addCriterion("user_name not like", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameIn(List<String> values) {
            addCriterion("user_name in", values, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameNotIn(List<String> values) {
            addCriterion("user_name not in", values, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameBetween(String value1, String value2) {
            addCriterion("user_name between", value1, value2, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameNotBetween(String value1, String value2) {
            addCriterion("user_name not between", value1, value2, "userName");
            return (Criteria) this;
        }

        public Criteria andUserPhoneIsNull() {
            addCriterion("user_phone is null");
            return (Criteria) this;
        }

        public Criteria andUserPhoneIsNotNull() {
            addCriterion("user_phone is not null");
            return (Criteria) this;
        }

        public Criteria andUserPhoneEqualTo(String value) {
            addCriterion("user_phone =", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneNotEqualTo(String value) {
            addCriterion("user_phone <>", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneGreaterThan(String value) {
            addCriterion("user_phone >", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneGreaterThanOrEqualTo(String value) {
            addCriterion("user_phone >=", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneLessThan(String value) {
            addCriterion("user_phone <", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneLessThanOrEqualTo(String value) {
            addCriterion("user_phone <=", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneLike(String value) {
            addCriterion("user_phone like", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneNotLike(String value) {
            addCriterion("user_phone not like", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneIn(List<String> values) {
            addCriterion("user_phone in", values, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneNotIn(List<String> values) {
            addCriterion("user_phone not in", values, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneBetween(String value1, String value2) {
            addCriterion("user_phone between", value1, value2, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneNotBetween(String value1, String value2) {
            addCriterion("user_phone not between", value1, value2, "userPhone");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIsNull() {
            addCriterion("goods_id is null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIsNotNull() {
            addCriterion("goods_id is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdEqualTo(Long value) {
            addCriterion("goods_id =", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotEqualTo(Long value) {
            addCriterion("goods_id <>", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdGreaterThan(Long value) {
            addCriterion("goods_id >", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdGreaterThanOrEqualTo(Long value) {
            addCriterion("goods_id >=", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdLessThan(Long value) {
            addCriterion("goods_id <", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdLessThanOrEqualTo(Long value) {
            addCriterion("goods_id <=", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIn(List<Long> values) {
            addCriterion("goods_id in", values, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotIn(List<Long> values) {
            addCriterion("goods_id not in", values, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdBetween(Long value1, Long value2) {
            addCriterion("goods_id between", value1, value2, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotBetween(Long value1, Long value2) {
            addCriterion("goods_id not between", value1, value2, "goodsId");
            return (Criteria) this;
        }

        public Criteria andRechargeContentIsNull() {
            addCriterion("recharge_content is null");
            return (Criteria) this;
        }

        public Criteria andRechargeContentIsNotNull() {
            addCriterion("recharge_content is not null");
            return (Criteria) this;
        }

        public Criteria andRechargeContentEqualTo(String value) {
            addCriterion("recharge_content =", value, "rechargeContent");
            return (Criteria) this;
        }

        public Criteria andRechargeContentNotEqualTo(String value) {
            addCriterion("recharge_content <>", value, "rechargeContent");
            return (Criteria) this;
        }

        public Criteria andRechargeContentGreaterThan(String value) {
            addCriterion("recharge_content >", value, "rechargeContent");
            return (Criteria) this;
        }

        public Criteria andRechargeContentGreaterThanOrEqualTo(String value) {
            addCriterion("recharge_content >=", value, "rechargeContent");
            return (Criteria) this;
        }

        public Criteria andRechargeContentLessThan(String value) {
            addCriterion("recharge_content <", value, "rechargeContent");
            return (Criteria) this;
        }

        public Criteria andRechargeContentLessThanOrEqualTo(String value) {
            addCriterion("recharge_content <=", value, "rechargeContent");
            return (Criteria) this;
        }

        public Criteria andRechargeContentLike(String value) {
            addCriterion("recharge_content like", value, "rechargeContent");
            return (Criteria) this;
        }

        public Criteria andRechargeContentNotLike(String value) {
            addCriterion("recharge_content not like", value, "rechargeContent");
            return (Criteria) this;
        }

        public Criteria andRechargeContentIn(List<String> values) {
            addCriterion("recharge_content in", values, "rechargeContent");
            return (Criteria) this;
        }

        public Criteria andRechargeContentNotIn(List<String> values) {
            addCriterion("recharge_content not in", values, "rechargeContent");
            return (Criteria) this;
        }

        public Criteria andRechargeContentBetween(String value1, String value2) {
            addCriterion("recharge_content between", value1, value2, "rechargeContent");
            return (Criteria) this;
        }

        public Criteria andRechargeContentNotBetween(String value1, String value2) {
            addCriterion("recharge_content not between", value1, value2, "rechargeContent");
            return (Criteria) this;
        }

        public Criteria andPayTypeIsNull() {
            addCriterion("pay_type is null");
            return (Criteria) this;
        }

        public Criteria andPayTypeIsNotNull() {
            addCriterion("pay_type is not null");
            return (Criteria) this;
        }

        public Criteria andPayTypeEqualTo(Integer value) {
            addCriterion("pay_type =", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeNotEqualTo(Integer value) {
            addCriterion("pay_type <>", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeGreaterThan(Integer value) {
            addCriterion("pay_type >", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("pay_type >=", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeLessThan(Integer value) {
            addCriterion("pay_type <", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeLessThanOrEqualTo(Integer value) {
            addCriterion("pay_type <=", value, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeIn(List<Integer> values) {
            addCriterion("pay_type in", values, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeNotIn(List<Integer> values) {
            addCriterion("pay_type not in", values, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeBetween(Integer value1, Integer value2) {
            addCriterion("pay_type between", value1, value2, "payType");
            return (Criteria) this;
        }

        public Criteria andPayTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("pay_type not between", value1, value2, "payType");
            return (Criteria) this;
        }

        public Criteria andLaborUnionCardIsNull() {
            addCriterion("labor_union_card is null");
            return (Criteria) this;
        }

        public Criteria andLaborUnionCardIsNotNull() {
            addCriterion("labor_union_card is not null");
            return (Criteria) this;
        }

        public Criteria andLaborUnionCardEqualTo(String value) {
            addCriterion("labor_union_card =", value, "laborUnionCard");
            return (Criteria) this;
        }

        public Criteria andLaborUnionCardNotEqualTo(String value) {
            addCriterion("labor_union_card <>", value, "laborUnionCard");
            return (Criteria) this;
        }

        public Criteria andLaborUnionCardGreaterThan(String value) {
            addCriterion("labor_union_card >", value, "laborUnionCard");
            return (Criteria) this;
        }

        public Criteria andLaborUnionCardGreaterThanOrEqualTo(String value) {
            addCriterion("labor_union_card >=", value, "laborUnionCard");
            return (Criteria) this;
        }

        public Criteria andLaborUnionCardLessThan(String value) {
            addCriterion("labor_union_card <", value, "laborUnionCard");
            return (Criteria) this;
        }

        public Criteria andLaborUnionCardLessThanOrEqualTo(String value) {
            addCriterion("labor_union_card <=", value, "laborUnionCard");
            return (Criteria) this;
        }

        public Criteria andLaborUnionCardLike(String value) {
            addCriterion("labor_union_card like", value, "laborUnionCard");
            return (Criteria) this;
        }

        public Criteria andLaborUnionCardNotLike(String value) {
            addCriterion("labor_union_card not like", value, "laborUnionCard");
            return (Criteria) this;
        }

        public Criteria andLaborUnionCardIn(List<String> values) {
            addCriterion("labor_union_card in", values, "laborUnionCard");
            return (Criteria) this;
        }

        public Criteria andLaborUnionCardNotIn(List<String> values) {
            addCriterion("labor_union_card not in", values, "laborUnionCard");
            return (Criteria) this;
        }

        public Criteria andLaborUnionCardBetween(String value1, String value2) {
            addCriterion("labor_union_card between", value1, value2, "laborUnionCard");
            return (Criteria) this;
        }

        public Criteria andLaborUnionCardNotBetween(String value1, String value2) {
            addCriterion("labor_union_card not between", value1, value2, "laborUnionCard");
            return (Criteria) this;
        }

        public Criteria andIntegralNumIsNull() {
            addCriterion("integral_num is null");
            return (Criteria) this;
        }

        public Criteria andIntegralNumIsNotNull() {
            addCriterion("integral_num is not null");
            return (Criteria) this;
        }

        public Criteria andIntegralNumEqualTo(BigDecimal value) {
            addCriterion("integral_num =", value, "integralNum");
            return (Criteria) this;
        }

        public Criteria andIntegralNumNotEqualTo(BigDecimal value) {
            addCriterion("integral_num <>", value, "integralNum");
            return (Criteria) this;
        }

        public Criteria andIntegralNumGreaterThan(BigDecimal value) {
            addCriterion("integral_num >", value, "integralNum");
            return (Criteria) this;
        }

        public Criteria andIntegralNumGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("integral_num >=", value, "integralNum");
            return (Criteria) this;
        }

        public Criteria andIntegralNumLessThan(BigDecimal value) {
            addCriterion("integral_num <", value, "integralNum");
            return (Criteria) this;
        }

        public Criteria andIntegralNumLessThanOrEqualTo(BigDecimal value) {
            addCriterion("integral_num <=", value, "integralNum");
            return (Criteria) this;
        }

        public Criteria andIntegralNumIn(List<BigDecimal> values) {
            addCriterion("integral_num in", values, "integralNum");
            return (Criteria) this;
        }

        public Criteria andIntegralNumNotIn(List<BigDecimal> values) {
            addCriterion("integral_num not in", values, "integralNum");
            return (Criteria) this;
        }

        public Criteria andIntegralNumBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("integral_num between", value1, value2, "integralNum");
            return (Criteria) this;
        }

        public Criteria andIntegralNumNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("integral_num not between", value1, value2, "integralNum");
            return (Criteria) this;
        }

        public Criteria andDiscountDeductionPriceIsNull() {
            addCriterion("discount_deduction_price is null");
            return (Criteria) this;
        }

        public Criteria andDiscountDeductionPriceIsNotNull() {
            addCriterion("discount_deduction_price is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountDeductionPriceEqualTo(BigDecimal value) {
            addCriterion("discount_deduction_price =", value, "discountDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountDeductionPriceNotEqualTo(BigDecimal value) {
            addCriterion("discount_deduction_price <>", value, "discountDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountDeductionPriceGreaterThan(BigDecimal value) {
            addCriterion("discount_deduction_price >", value, "discountDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountDeductionPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("discount_deduction_price >=", value, "discountDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountDeductionPriceLessThan(BigDecimal value) {
            addCriterion("discount_deduction_price <", value, "discountDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountDeductionPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("discount_deduction_price <=", value, "discountDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountDeductionPriceIn(List<BigDecimal> values) {
            addCriterion("discount_deduction_price in", values, "discountDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountDeductionPriceNotIn(List<BigDecimal> values) {
            addCriterion("discount_deduction_price not in", values, "discountDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountDeductionPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("discount_deduction_price between", value1, value2, "discountDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountDeductionPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("discount_deduction_price not between", value1, value2, "discountDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDeductionPriceIsNull() {
            addCriterion("integral_deduction_price is null");
            return (Criteria) this;
        }

        public Criteria andIntegralDeductionPriceIsNotNull() {
            addCriterion("integral_deduction_price is not null");
            return (Criteria) this;
        }

        public Criteria andIntegralDeductionPriceEqualTo(BigDecimal value) {
            addCriterion("integral_deduction_price =", value, "integralDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDeductionPriceNotEqualTo(BigDecimal value) {
            addCriterion("integral_deduction_price <>", value, "integralDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDeductionPriceGreaterThan(BigDecimal value) {
            addCriterion("integral_deduction_price >", value, "integralDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDeductionPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("integral_deduction_price >=", value, "integralDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDeductionPriceLessThan(BigDecimal value) {
            addCriterion("integral_deduction_price <", value, "integralDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDeductionPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("integral_deduction_price <=", value, "integralDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDeductionPriceIn(List<BigDecimal> values) {
            addCriterion("integral_deduction_price in", values, "integralDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDeductionPriceNotIn(List<BigDecimal> values) {
            addCriterion("integral_deduction_price not in", values, "integralDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDeductionPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("integral_deduction_price between", value1, value2, "integralDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andIntegralDeductionPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("integral_deduction_price not between", value1, value2, "integralDeductionPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceIsNull() {
            addCriterion("pay_price is null");
            return (Criteria) this;
        }

        public Criteria andPayPriceIsNotNull() {
            addCriterion("pay_price is not null");
            return (Criteria) this;
        }

        public Criteria andPayPriceEqualTo(BigDecimal value) {
            addCriterion("pay_price =", value, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceNotEqualTo(BigDecimal value) {
            addCriterion("pay_price <>", value, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceGreaterThan(BigDecimal value) {
            addCriterion("pay_price >", value, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("pay_price >=", value, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceLessThan(BigDecimal value) {
            addCriterion("pay_price <", value, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("pay_price <=", value, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceIn(List<BigDecimal> values) {
            addCriterion("pay_price in", values, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceNotIn(List<BigDecimal> values) {
            addCriterion("pay_price not in", values, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("pay_price between", value1, value2, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("pay_price not between", value1, value2, "payPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceIsNull() {
            addCriterion("pay_real_price is null");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceIsNotNull() {
            addCriterion("pay_real_price is not null");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceEqualTo(BigDecimal value) {
            addCriterion("pay_real_price =", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceNotEqualTo(BigDecimal value) {
            addCriterion("pay_real_price <>", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceGreaterThan(BigDecimal value) {
            addCriterion("pay_real_price >", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("pay_real_price >=", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceLessThan(BigDecimal value) {
            addCriterion("pay_real_price <", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("pay_real_price <=", value, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceIn(List<BigDecimal> values) {
            addCriterion("pay_real_price in", values, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceNotIn(List<BigDecimal> values) {
            addCriterion("pay_real_price not in", values, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("pay_real_price between", value1, value2, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPayRealPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("pay_real_price not between", value1, value2, "payRealPrice");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoIsNull() {
            addCriterion("pay_serial_no is null");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoIsNotNull() {
            addCriterion("pay_serial_no is not null");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoEqualTo(String value) {
            addCriterion("pay_serial_no =", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoNotEqualTo(String value) {
            addCriterion("pay_serial_no <>", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoGreaterThan(String value) {
            addCriterion("pay_serial_no >", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoGreaterThanOrEqualTo(String value) {
            addCriterion("pay_serial_no >=", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoLessThan(String value) {
            addCriterion("pay_serial_no <", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoLessThanOrEqualTo(String value) {
            addCriterion("pay_serial_no <=", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoLike(String value) {
            addCriterion("pay_serial_no like", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoNotLike(String value) {
            addCriterion("pay_serial_no not like", value, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoIn(List<String> values) {
            addCriterion("pay_serial_no in", values, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoNotIn(List<String> values) {
            addCriterion("pay_serial_no not in", values, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoBetween(String value1, String value2) {
            addCriterion("pay_serial_no between", value1, value2, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andPaySerialNoNotBetween(String value1, String value2) {
            addCriterion("pay_serial_no not between", value1, value2, "paySerialNo");
            return (Criteria) this;
        }

        public Criteria andCreateTimedIsNull() {
            addCriterion("create_timed is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimedIsNotNull() {
            addCriterion("create_timed is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimedEqualTo(Date value) {
            addCriterion("create_timed =", value, "createTimed");
            return (Criteria) this;
        }

        public Criteria andCreateTimedNotEqualTo(Date value) {
            addCriterion("create_timed <>", value, "createTimed");
            return (Criteria) this;
        }

        public Criteria andCreateTimedGreaterThan(Date value) {
            addCriterion("create_timed >", value, "createTimed");
            return (Criteria) this;
        }

        public Criteria andCreateTimedGreaterThanOrEqualTo(Date value) {
            addCriterion("create_timed >=", value, "createTimed");
            return (Criteria) this;
        }

        public Criteria andCreateTimedLessThan(Date value) {
            addCriterion("create_timed <", value, "createTimed");
            return (Criteria) this;
        }

        public Criteria andCreateTimedLessThanOrEqualTo(Date value) {
            addCriterion("create_timed <=", value, "createTimed");
            return (Criteria) this;
        }

        public Criteria andCreateTimedIn(List<Date> values) {
            addCriterion("create_timed in", values, "createTimed");
            return (Criteria) this;
        }

        public Criteria andCreateTimedNotIn(List<Date> values) {
            addCriterion("create_timed not in", values, "createTimed");
            return (Criteria) this;
        }

        public Criteria andCreateTimedBetween(Date value1, Date value2) {
            addCriterion("create_timed between", value1, value2, "createTimed");
            return (Criteria) this;
        }

        public Criteria andCreateTimedNotBetween(Date value1, Date value2) {
            addCriterion("create_timed not between", value1, value2, "createTimed");
            return (Criteria) this;
        }

        public Criteria andPayTimeIsNull() {
            addCriterion("pay_time is null");
            return (Criteria) this;
        }

        public Criteria andPayTimeIsNotNull() {
            addCriterion("pay_time is not null");
            return (Criteria) this;
        }

        public Criteria andPayTimeEqualTo(Date value) {
            addCriterion("pay_time =", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeNotEqualTo(Date value) {
            addCriterion("pay_time <>", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeGreaterThan(Date value) {
            addCriterion("pay_time >", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("pay_time >=", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeLessThan(Date value) {
            addCriterion("pay_time <", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeLessThanOrEqualTo(Date value) {
            addCriterion("pay_time <=", value, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeIn(List<Date> values) {
            addCriterion("pay_time in", values, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeNotIn(List<Date> values) {
            addCriterion("pay_time not in", values, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeBetween(Date value1, Date value2) {
            addCriterion("pay_time between", value1, value2, "payTime");
            return (Criteria) this;
        }

        public Criteria andPayTimeNotBetween(Date value1, Date value2) {
            addCriterion("pay_time not between", value1, value2, "payTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeIsNull() {
            addCriterion("cancel_time is null");
            return (Criteria) this;
        }

        public Criteria andCancelTimeIsNotNull() {
            addCriterion("cancel_time is not null");
            return (Criteria) this;
        }

        public Criteria andCancelTimeEqualTo(Date value) {
            addCriterion("cancel_time =", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeNotEqualTo(Date value) {
            addCriterion("cancel_time <>", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeGreaterThan(Date value) {
            addCriterion("cancel_time >", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("cancel_time >=", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeLessThan(Date value) {
            addCriterion("cancel_time <", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeLessThanOrEqualTo(Date value) {
            addCriterion("cancel_time <=", value, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeIn(List<Date> values) {
            addCriterion("cancel_time in", values, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeNotIn(List<Date> values) {
            addCriterion("cancel_time not in", values, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeBetween(Date value1, Date value2) {
            addCriterion("cancel_time between", value1, value2, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andCancelTimeNotBetween(Date value1, Date value2) {
            addCriterion("cancel_time not between", value1, value2, "cancelTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeIsNull() {
            addCriterion("finish_time is null");
            return (Criteria) this;
        }

        public Criteria andFinishTimeIsNotNull() {
            addCriterion("finish_time is not null");
            return (Criteria) this;
        }

        public Criteria andFinishTimeEqualTo(Date value) {
            addCriterion("finish_time =", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeNotEqualTo(Date value) {
            addCriterion("finish_time <>", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeGreaterThan(Date value) {
            addCriterion("finish_time >", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("finish_time >=", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeLessThan(Date value) {
            addCriterion("finish_time <", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeLessThanOrEqualTo(Date value) {
            addCriterion("finish_time <=", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeIn(List<Date> values) {
            addCriterion("finish_time in", values, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeNotIn(List<Date> values) {
            addCriterion("finish_time not in", values, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeBetween(Date value1, Date value2) {
            addCriterion("finish_time between", value1, value2, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeNotBetween(Date value1, Date value2) {
            addCriterion("finish_time not between", value1, value2, "finishTime");
            return (Criteria) this;
        }

        public Criteria andOutRefundNoIsNull() {
            addCriterion("out_refund_no is null");
            return (Criteria) this;
        }

        public Criteria andOutRefundNoIsNotNull() {
            addCriterion("out_refund_no is not null");
            return (Criteria) this;
        }

        public Criteria andOutRefundNoEqualTo(String value) {
            addCriterion("out_refund_no =", value, "outRefundNo");
            return (Criteria) this;
        }

        public Criteria andOutRefundNoNotEqualTo(String value) {
            addCriterion("out_refund_no <>", value, "outRefundNo");
            return (Criteria) this;
        }

        public Criteria andOutRefundNoGreaterThan(String value) {
            addCriterion("out_refund_no >", value, "outRefundNo");
            return (Criteria) this;
        }

        public Criteria andOutRefundNoGreaterThanOrEqualTo(String value) {
            addCriterion("out_refund_no >=", value, "outRefundNo");
            return (Criteria) this;
        }

        public Criteria andOutRefundNoLessThan(String value) {
            addCriterion("out_refund_no <", value, "outRefundNo");
            return (Criteria) this;
        }

        public Criteria andOutRefundNoLessThanOrEqualTo(String value) {
            addCriterion("out_refund_no <=", value, "outRefundNo");
            return (Criteria) this;
        }

        public Criteria andOutRefundNoLike(String value) {
            addCriterion("out_refund_no like", value, "outRefundNo");
            return (Criteria) this;
        }

        public Criteria andOutRefundNoNotLike(String value) {
            addCriterion("out_refund_no not like", value, "outRefundNo");
            return (Criteria) this;
        }

        public Criteria andOutRefundNoIn(List<String> values) {
            addCriterion("out_refund_no in", values, "outRefundNo");
            return (Criteria) this;
        }

        public Criteria andOutRefundNoNotIn(List<String> values) {
            addCriterion("out_refund_no not in", values, "outRefundNo");
            return (Criteria) this;
        }

        public Criteria andOutRefundNoBetween(String value1, String value2) {
            addCriterion("out_refund_no between", value1, value2, "outRefundNo");
            return (Criteria) this;
        }

        public Criteria andOutRefundNoNotBetween(String value1, String value2) {
            addCriterion("out_refund_no not between", value1, value2, "outRefundNo");
            return (Criteria) this;
        }

        public Criteria andOrderPriceIsNull() {
            addCriterion("order_price is null");
            return (Criteria) this;
        }

        public Criteria andOrderPriceIsNotNull() {
            addCriterion("order_price is not null");
            return (Criteria) this;
        }

        public Criteria andOrderPriceEqualTo(BigDecimal value) {
            addCriterion("order_price =", value, "orderPrice");
            return (Criteria) this;
        }

        public Criteria andOrderPriceNotEqualTo(BigDecimal value) {
            addCriterion("order_price <>", value, "orderPrice");
            return (Criteria) this;
        }

        public Criteria andOrderPriceGreaterThan(BigDecimal value) {
            addCriterion("order_price >", value, "orderPrice");
            return (Criteria) this;
        }

        public Criteria andOrderPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("order_price >=", value, "orderPrice");
            return (Criteria) this;
        }

        public Criteria andOrderPriceLessThan(BigDecimal value) {
            addCriterion("order_price <", value, "orderPrice");
            return (Criteria) this;
        }

        public Criteria andOrderPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("order_price <=", value, "orderPrice");
            return (Criteria) this;
        }

        public Criteria andOrderPriceIn(List<BigDecimal> values) {
            addCriterion("order_price in", values, "orderPrice");
            return (Criteria) this;
        }

        public Criteria andOrderPriceNotIn(List<BigDecimal> values) {
            addCriterion("order_price not in", values, "orderPrice");
            return (Criteria) this;
        }

        public Criteria andOrderPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("order_price between", value1, value2, "orderPrice");
            return (Criteria) this;
        }

        public Criteria andOrderPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("order_price not between", value1, value2, "orderPrice");
            return (Criteria) this;
        }

        public Criteria andRefundTimeIsNull() {
            addCriterion("refund_time is null");
            return (Criteria) this;
        }

        public Criteria andRefundTimeIsNotNull() {
            addCriterion("refund_time is not null");
            return (Criteria) this;
        }

        public Criteria andRefundTimeEqualTo(Date value) {
            addCriterion("refund_time =", value, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeNotEqualTo(Date value) {
            addCriterion("refund_time <>", value, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeGreaterThan(Date value) {
            addCriterion("refund_time >", value, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("refund_time >=", value, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeLessThan(Date value) {
            addCriterion("refund_time <", value, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeLessThanOrEqualTo(Date value) {
            addCriterion("refund_time <=", value, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeIn(List<Date> values) {
            addCriterion("refund_time in", values, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeNotIn(List<Date> values) {
            addCriterion("refund_time not in", values, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeBetween(Date value1, Date value2) {
            addCriterion("refund_time between", value1, value2, "refundTime");
            return (Criteria) this;
        }

        public Criteria andRefundTimeNotBetween(Date value1, Date value2) {
            addCriterion("refund_time not between", value1, value2, "refundTime");
            return (Criteria) this;
        }

        public Criteria andTpRefundOrderNoIsNull() {
            addCriterion("tp_refund_order_no is null");
            return (Criteria) this;
        }

        public Criteria andTpRefundOrderNoIsNotNull() {
            addCriterion("tp_refund_order_no is not null");
            return (Criteria) this;
        }

        public Criteria andTpRefundOrderNoEqualTo(String value) {
            addCriterion("tp_refund_order_no =", value, "tpRefundOrderNo");
            return (Criteria) this;
        }

        public Criteria andTpRefundOrderNoNotEqualTo(String value) {
            addCriterion("tp_refund_order_no <>", value, "tpRefundOrderNo");
            return (Criteria) this;
        }

        public Criteria andTpRefundOrderNoGreaterThan(String value) {
            addCriterion("tp_refund_order_no >", value, "tpRefundOrderNo");
            return (Criteria) this;
        }

        public Criteria andTpRefundOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("tp_refund_order_no >=", value, "tpRefundOrderNo");
            return (Criteria) this;
        }

        public Criteria andTpRefundOrderNoLessThan(String value) {
            addCriterion("tp_refund_order_no <", value, "tpRefundOrderNo");
            return (Criteria) this;
        }

        public Criteria andTpRefundOrderNoLessThanOrEqualTo(String value) {
            addCriterion("tp_refund_order_no <=", value, "tpRefundOrderNo");
            return (Criteria) this;
        }

        public Criteria andTpRefundOrderNoLike(String value) {
            addCriterion("tp_refund_order_no like", value, "tpRefundOrderNo");
            return (Criteria) this;
        }

        public Criteria andTpRefundOrderNoNotLike(String value) {
            addCriterion("tp_refund_order_no not like", value, "tpRefundOrderNo");
            return (Criteria) this;
        }

        public Criteria andTpRefundOrderNoIn(List<String> values) {
            addCriterion("tp_refund_order_no in", values, "tpRefundOrderNo");
            return (Criteria) this;
        }

        public Criteria andTpRefundOrderNoNotIn(List<String> values) {
            addCriterion("tp_refund_order_no not in", values, "tpRefundOrderNo");
            return (Criteria) this;
        }

        public Criteria andTpRefundOrderNoBetween(String value1, String value2) {
            addCriterion("tp_refund_order_no between", value1, value2, "tpRefundOrderNo");
            return (Criteria) this;
        }

        public Criteria andTpRefundOrderNoNotBetween(String value1, String value2) {
            addCriterion("tp_refund_order_no not between", value1, value2, "tpRefundOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundIdIsNull() {
            addCriterion("refund_id is null");
            return (Criteria) this;
        }

        public Criteria andRefundIdIsNotNull() {
            addCriterion("refund_id is not null");
            return (Criteria) this;
        }

        public Criteria andRefundIdEqualTo(String value) {
            addCriterion("refund_id =", value, "refundId");
            return (Criteria) this;
        }

        public Criteria andRefundIdNotEqualTo(String value) {
            addCriterion("refund_id <>", value, "refundId");
            return (Criteria) this;
        }

        public Criteria andRefundIdGreaterThan(String value) {
            addCriterion("refund_id >", value, "refundId");
            return (Criteria) this;
        }

        public Criteria andRefundIdGreaterThanOrEqualTo(String value) {
            addCriterion("refund_id >=", value, "refundId");
            return (Criteria) this;
        }

        public Criteria andRefundIdLessThan(String value) {
            addCriterion("refund_id <", value, "refundId");
            return (Criteria) this;
        }

        public Criteria andRefundIdLessThanOrEqualTo(String value) {
            addCriterion("refund_id <=", value, "refundId");
            return (Criteria) this;
        }

        public Criteria andRefundIdLike(String value) {
            addCriterion("refund_id like", value, "refundId");
            return (Criteria) this;
        }

        public Criteria andRefundIdNotLike(String value) {
            addCriterion("refund_id not like", value, "refundId");
            return (Criteria) this;
        }

        public Criteria andRefundIdIn(List<String> values) {
            addCriterion("refund_id in", values, "refundId");
            return (Criteria) this;
        }

        public Criteria andRefundIdNotIn(List<String> values) {
            addCriterion("refund_id not in", values, "refundId");
            return (Criteria) this;
        }

        public Criteria andRefundIdBetween(String value1, String value2) {
            addCriterion("refund_id between", value1, value2, "refundId");
            return (Criteria) this;
        }

        public Criteria andRefundIdNotBetween(String value1, String value2) {
            addCriterion("refund_id not between", value1, value2, "refundId");
            return (Criteria) this;
        }

        public Criteria andRefundFeeIsNull() {
            addCriterion("refund_fee is null");
            return (Criteria) this;
        }

        public Criteria andRefundFeeIsNotNull() {
            addCriterion("refund_fee is not null");
            return (Criteria) this;
        }

        public Criteria andRefundFeeEqualTo(BigDecimal value) {
            addCriterion("refund_fee =", value, "refundFee");
            return (Criteria) this;
        }

        public Criteria andRefundFeeNotEqualTo(BigDecimal value) {
            addCriterion("refund_fee <>", value, "refundFee");
            return (Criteria) this;
        }

        public Criteria andRefundFeeGreaterThan(BigDecimal value) {
            addCriterion("refund_fee >", value, "refundFee");
            return (Criteria) this;
        }

        public Criteria andRefundFeeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("refund_fee >=", value, "refundFee");
            return (Criteria) this;
        }

        public Criteria andRefundFeeLessThan(BigDecimal value) {
            addCriterion("refund_fee <", value, "refundFee");
            return (Criteria) this;
        }

        public Criteria andRefundFeeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("refund_fee <=", value, "refundFee");
            return (Criteria) this;
        }

        public Criteria andRefundFeeIn(List<BigDecimal> values) {
            addCriterion("refund_fee in", values, "refundFee");
            return (Criteria) this;
        }

        public Criteria andRefundFeeNotIn(List<BigDecimal> values) {
            addCriterion("refund_fee not in", values, "refundFee");
            return (Criteria) this;
        }

        public Criteria andRefundFeeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("refund_fee between", value1, value2, "refundFee");
            return (Criteria) this;
        }

        public Criteria andRefundFeeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("refund_fee not between", value1, value2, "refundFee");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNull() {
            addCriterion("company_id is null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNotNull() {
            addCriterion("company_id is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdEqualTo(Long value) {
            addCriterion("company_id =", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotEqualTo(Long value) {
            addCriterion("company_id <>", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThan(Long value) {
            addCriterion("company_id >", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThanOrEqualTo(Long value) {
            addCriterion("company_id >=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThan(Long value) {
            addCriterion("company_id <", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThanOrEqualTo(Long value) {
            addCriterion("company_id <=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIn(List<Long> values) {
            addCriterion("company_id in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotIn(List<Long> values) {
            addCriterion("company_id not in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdBetween(Long value1, Long value2) {
            addCriterion("company_id between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotBetween(Long value1, Long value2) {
            addCriterion("company_id not between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andPayStatusIsNull() {
            addCriterion("pay_status is null");
            return (Criteria) this;
        }

        public Criteria andPayStatusIsNotNull() {
            addCriterion("pay_status is not null");
            return (Criteria) this;
        }

        public Criteria andPayStatusEqualTo(Integer value) {
            addCriterion("pay_status =", value, "payStatus");
            return (Criteria) this;
        }

        public Criteria andPayStatusNotEqualTo(Integer value) {
            addCriterion("pay_status <>", value, "payStatus");
            return (Criteria) this;
        }

        public Criteria andPayStatusGreaterThan(Integer value) {
            addCriterion("pay_status >", value, "payStatus");
            return (Criteria) this;
        }

        public Criteria andPayStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("pay_status >=", value, "payStatus");
            return (Criteria) this;
        }

        public Criteria andPayStatusLessThan(Integer value) {
            addCriterion("pay_status <", value, "payStatus");
            return (Criteria) this;
        }

        public Criteria andPayStatusLessThanOrEqualTo(Integer value) {
            addCriterion("pay_status <=", value, "payStatus");
            return (Criteria) this;
        }

        public Criteria andPayStatusIn(List<Integer> values) {
            addCriterion("pay_status in", values, "payStatus");
            return (Criteria) this;
        }

        public Criteria andPayStatusNotIn(List<Integer> values) {
            addCriterion("pay_status not in", values, "payStatus");
            return (Criteria) this;
        }

        public Criteria andPayStatusBetween(Integer value1, Integer value2) {
            addCriterion("pay_status between", value1, value2, "payStatus");
            return (Criteria) this;
        }

        public Criteria andPayStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("pay_status not between", value1, value2, "payStatus");
            return (Criteria) this;
        }

        public Criteria andMerchIdIsNull() {
            addCriterion("merch_id is null");
            return (Criteria) this;
        }

        public Criteria andMerchIdIsNotNull() {
            addCriterion("merch_id is not null");
            return (Criteria) this;
        }

        public Criteria andMerchIdEqualTo(String value) {
            addCriterion("merch_id =", value, "merchId");
            return (Criteria) this;
        }

        public Criteria andMerchIdNotEqualTo(String value) {
            addCriterion("merch_id <>", value, "merchId");
            return (Criteria) this;
        }

        public Criteria andMerchIdGreaterThan(String value) {
            addCriterion("merch_id >", value, "merchId");
            return (Criteria) this;
        }

        public Criteria andMerchIdGreaterThanOrEqualTo(String value) {
            addCriterion("merch_id >=", value, "merchId");
            return (Criteria) this;
        }

        public Criteria andMerchIdLessThan(String value) {
            addCriterion("merch_id <", value, "merchId");
            return (Criteria) this;
        }

        public Criteria andMerchIdLessThanOrEqualTo(String value) {
            addCriterion("merch_id <=", value, "merchId");
            return (Criteria) this;
        }

        public Criteria andMerchIdLike(String value) {
            addCriterion("merch_id like", value, "merchId");
            return (Criteria) this;
        }

        public Criteria andMerchIdNotLike(String value) {
            addCriterion("merch_id not like", value, "merchId");
            return (Criteria) this;
        }

        public Criteria andMerchIdIn(List<String> values) {
            addCriterion("merch_id in", values, "merchId");
            return (Criteria) this;
        }

        public Criteria andMerchIdNotIn(List<String> values) {
            addCriterion("merch_id not in", values, "merchId");
            return (Criteria) this;
        }

        public Criteria andMerchIdBetween(String value1, String value2) {
            addCriterion("merch_id between", value1, value2, "merchId");
            return (Criteria) this;
        }

        public Criteria andMerchIdNotBetween(String value1, String value2) {
            addCriterion("merch_id not between", value1, value2, "merchId");
            return (Criteria) this;
        }

        public Criteria andRechargeStatusIsNull() {
            addCriterion("recharge_status is null");
            return (Criteria) this;
        }

        public Criteria andRechargeStatusIsNotNull() {
            addCriterion("recharge_status is not null");
            return (Criteria) this;
        }

        public Criteria andRechargeStatusEqualTo(Integer value) {
            addCriterion("recharge_status =", value, "rechargeStatus");
            return (Criteria) this;
        }

        public Criteria andRechargeStatusNotEqualTo(Integer value) {
            addCriterion("recharge_status <>", value, "rechargeStatus");
            return (Criteria) this;
        }

        public Criteria andRechargeStatusGreaterThan(Integer value) {
            addCriterion("recharge_status >", value, "rechargeStatus");
            return (Criteria) this;
        }

        public Criteria andRechargeStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("recharge_status >=", value, "rechargeStatus");
            return (Criteria) this;
        }

        public Criteria andRechargeStatusLessThan(Integer value) {
            addCriterion("recharge_status <", value, "rechargeStatus");
            return (Criteria) this;
        }

        public Criteria andRechargeStatusLessThanOrEqualTo(Integer value) {
            addCriterion("recharge_status <=", value, "rechargeStatus");
            return (Criteria) this;
        }

        public Criteria andRechargeStatusIn(List<Integer> values) {
            addCriterion("recharge_status in", values, "rechargeStatus");
            return (Criteria) this;
        }

        public Criteria andRechargeStatusNotIn(List<Integer> values) {
            addCriterion("recharge_status not in", values, "rechargeStatus");
            return (Criteria) this;
        }

        public Criteria andRechargeStatusBetween(Integer value1, Integer value2) {
            addCriterion("recharge_status between", value1, value2, "rechargeStatus");
            return (Criteria) this;
        }

        public Criteria andRechargeStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("recharge_status not between", value1, value2, "rechargeStatus");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}